var fM = {

		
	init: function() 
	{
		if (!document.getElementById || !document.getElementsByTagName ||
			!Drag || !Drag.init)
		  return;
		
    
		fM.current_path="/";
		
		
		// Load the initial fileset
    	fM.loadFiles(fM.current_path);
	},
  
  	setTargets: function()
  	{
		// Make the targets remove the element when dropped upon
		var elements = document.getElementsByTagName('*');
		for (var i = 0; i < elements.length; i++) 
		{
			var t = elements[i];
			if (t.className.search(/\btarget\b/) != -1) 
			{
				//alert("href=["+t.href+"]");
				t.onDroppedOn = fM.moveFileHere;
			}
		}  	
  	},
  	
  	setUpDraggables: function() 
  	{
    	var elements = document.getElementsByTagName('*');
    	for (var i = 0; i < elements.length; i++) 
    	{
			var draggable = elements[i];
      		if (draggable.className.search(/\bdraggable\b/) != -1) 
      		{
        		Drag.init(draggable);
        
				draggable.onDragStart = function(x, y) 
				{
					document.body.className += ' dragging';
					fM.createProxyTargets();
					this.ZINDEX = this.style.zIndex;
					this.style.zIndex = 999;
					this.SAVED_POSITION = [x, y];
				};
        
				draggable.onDragEnd = function(x, y) 
				{
					this.style.left = this.SAVED_POSITION[0];
					this.style.top = this.SAVED_POSITION[1];
					this.style.zIndex = this.ZINDEX;
					fM.elementDropped(this, x, y);
					fM.removeProxyTargets();
					document.body.className = document.body.className.replace(/\b ?dragging\b/, '');
				};
			}
		}
	},

	createProxyTargets: function() 
	{
	    fM.PROXY_TARGETS = [];
	    var targets = document.getElementsByTagName('*');
	    for (var i = 0; i < targets.length; i++) 
	    {
			var t = targets[i];
			if (t.className.search(/\btarget\b/) != -1) 
			{
				var proxyTarget = document.createElement('a');
				proxyTarget.className = 'proxyTarget';
				proxyTarget.style.left = fM.findPosX(t) + 'px';
				proxyTarget.style.top = fM.findPosY(t) + 'px';
				proxyTarget.style.width = t.offsetWidth + 'px';
				proxyTarget.style.height = t.offsetHeight + 'px';
				proxyTarget.href = '#';
				proxyTarget.realElement = t;
				
				fM.PROXY_TARGETS[fM.PROXY_TARGETS.length] = proxyTarget;
				document.body.appendChild(proxyTarget);
				
				fM.addEvent(proxyTarget, 'mouseover', fM.targetOver, false);
				fM.addEvent(proxyTarget, 'mouseout', fM.targetOut, false);
			}
		}
	},

	removeProxyTargets: function() 
	{
		for (var i = 0; i < fM.PROXY_TARGETS.length; i++) 
		{
			var tt = fM.PROXY_TARGETS[i].realElement;
			tt.className = tt.className.replace(/\bhover\b/, '');
			document.body.removeChild(fM.PROXY_TARGETS[i]);
		}
		fM.PROXY_TARGETS = [];
	},

	targetOver: function(e) 
	{
		var t = window.event ? window.event.srcElement : e ? e.target : null;
		if (!t) return;

		var tt = t.realElement;
		tt.className += ' hover';
	},

	targetOut: function(e) 
	{
    	var t = window.event ? window.event.srcElement : e ? e.target : null;
    	if (!t) return;
    	var tt = t.realElement;
    	tt.className = tt.className.replace(/\b ?hover\b/, '');
  	},

	elementDropped: function(draggedObj, x, y) 
	{
    	var elements = document.getElementsByTagName('*');
    	for (var i = 0; i < elements.length; i++) 
    	{
      		var t = elements[i];

      		if (t.className.search(/\btarget\b/) != -1 &&
          		t.className.search(/\bhover\b/) != -1 && t.onDroppedOn) 
          	{
        		t.onDroppedOn(draggedObj);
      		}
    	}
  	},
  
	moveFileHere: function(dragged) 
	{
		var dest_path = this.href.split("?");
		
		var src_file = "";
		if (fM.current_path == "/")
			src_file = "";
		else
			src_file = fM.current_path + "/";
		src_file = src_file+dragged.firstChild.nodeValue;

		var file = fM.current_path+"/"+dragged.firstChild.nodeValue;
		var path = this.href;
		
		var xmlhttp = Sarissa.getXmlHttpRequest();

//		var qs = '?path=' + escape(path) + '&file=' + escape(file);
		var qs = '?' + dest_path[1] + '&file=' + src_file;
		
		var url = 'moveFiles.php' + qs;
		xmlhttp.open('GET', url, true);
		xmlhttp.onreadystatechange = function() 
		{
		  if (xmlhttp.readyState == 4) 
		  {
			fM.receiveMoveDetails(xmlhttp.responseText, dragged);
		  }
    	};
    	xmlhttp.send(null);
  	},
  
	receiveMoveDetails: function(data, dragged) 
	{
	    if (data == 'OK') 
	    {
			dragged.parentNode.removeChild(dragged);
    	} 
    	else 
    	{
			alert('There was an error moving the file:\n' + data);
		}

    	fM.loadFiles(fM.current_path);
	},
  
	openFolder: function(e) 
	{
    	var t = window.event ? window.event.srcElement : e ? e.target : null;
    	if (!t) return;

    	while (t.nodeName.toLowerCase() != 'a' && t.nodeName.toLowerCase() != 'body')
			t = t.parentNode;

		var t_t 		= t.getAttribute('href');
		var t_t_array 	= t_t.split('?');
		var path_array 	= t_t_array[1].split("=");
		
		fM.loadFiles(path_array[1]);
	    if (window.event) 
	    {
			window.event.cancelBubble = true;
			window.event.returnValue = false;
		}
		if (e && e.stopPropagation && e.preventDefault) 
		{
			e.stopPropagation();
			e.preventDefault();
		}
	},
  
	loadFiles: function(path) 
	{
	    var files = document.getElementById('files_body');
		files.innerHTML = 'loading files...';

		var xmlhttp = Sarissa.getXmlHttpRequest();
		var url = 'getFiles.php?rnd=' + (new Date()).getTime() + '&path=' + escape(path);

		xmlhttp.open('GET', url, true);
		xmlhttp.onreadystatechange = function() 
		{
			if (xmlhttp.readyState == 4) 
			{
				fM.receiveFolders(xmlhttp.responseXML, path);
				fM.receiveFilenames(xmlhttp.responseXML, path);
			}
		};
		xmlhttp.send(null);
	},
  
	receiveFolders: function(dom, path) 
	{
/* Structure of Folders content

	<div id="folders">
		<h3><span>Folders</span></h3>
		<ul class="aqtree3clickable">

			<li>
			
				<a href="/" path="/" class="target">/</a>
				<ul>
				
					<li>
						<a href="/php-scripts/" class="target">php-scripts</a> 		<-- This is a possible li_root
					</li>
					<li>
						<a href="resources/" class="target">resources</a>			<-- This is a possible li_root
						<ul>
							<li>
								<a href="resources/png-images/" class="target">png-images</a>
							</li>
							<li>
								<a href="resources/mp3/" class="target">mp3</a>
							</li>
						</ul>
					</li>
					
				</ul>
			
			</li>

		</ul>
	</div>
*/

		fM.current_path=path;

    	var parent_path_items = dom.getElementsByTagName('parent_path');
    	var parent_path = "";
    	for (var i = 0; i < parent_path_items.length; i++) 
    	{
			parent_path = parent_path_items[i].firstChild.nodeValue;
		}
		
		// By default set the position to the root of the tree.
		var folders_li_ref = document.getElementById('folders_body');

		// Then we try annd find the match down the tree.
		// Get a list of all links (and sub-links) in the folders section/DIV
		// Note. The 'folders_li_ref above is what we want. In other words the following
		// line will provide access to an anchor that is contented. We will need to 
		// get the parentNode from the anchor found to properly refernce the li
 		var folders_anchors_ref = document.getElementById('folders_body').getElementsByTagName('a');

		// Start reading through trying to find the one that matches the full path.
		// There has to be a BETTER way for this. Maybe some changes in version 1.1
		for (var i = 0; i < folders_anchors_ref.length; i++) 
		{			
			var anchor_href 		= folders_anchors_ref[i].getAttribute('href');

			// We take the HREF from the link. Split off the value to the righ of the '?'
			// and check it against the parent_path. If we find a match we break because 
			//this is where we want to be. 
			var href_array = anchor_href.split("?");
			if (href_array.length > 1)
			{
				var tmp_array = href_array[1].split("=");

				if (parent_path == tmp_array[1])
				{
					folders_li_ref = folders_anchors_ref[i].parentNode;

//					var n_childNodes = folders_li_ref.childNodes;
//					if (n_childNodes.length > 0)
//					{
//						alert("n_childNodes=["+n_childNodes.length+"]");
//						for(var idx = 0; idx < n_childNodes.length; dx--) 
//						{  
 //       					folders_li_ref.removeChild(n_childNodes[idx]);
//					    }
//					}
					break;
				}
			}
   		}
   		
// BUG: If you click on the folder more than once it will create duplicate listings,
//		appended to the bottom of the list. Need to clear the UL child node before building a new one.


		var ul_folders = document.createElement('ul');
	   	ul_folders.className= "aqtree3clickable";

		folders_li_ref.appendChild(ul_folders);
	    
    	var folderNodes = dom.getElementsByTagName('folder');

    	for (var i = 0; i < folderNodes.length; i++) 
    	{
			var li_folder = document.createElement('li');
			li_folder.className="aq3bullet";

			var folder_a = document.createElement('a');

			if (parent_path == "/")
				folder_a.href= location.href + "?path=/"+folderNodes[i].firstChild.nodeValue;
			else
				folder_a.href= location.href + "?path="+parent_path+"/"+folderNodes[i].firstChild.nodeValue;

//			folder_a.addAttribute("path", ");				

			folder_a.className = "target";
//			folder_a.className = "current_path";

			var folder_a_tn = document.createTextNode(folderNodes[i].firstChild.nodeValue);
			folder_a.appendChild(folder_a_tn);
			li_folder.appendChild(folder_a);

//			if (parent_path == "/")
//				folder_a.setAttribute('path', folderNodes[i].firstChild.nodeValue);
//			else
//				folder_a.setAttribute('path', parent_path + '/' + folderNodes[i].firstChild.nodeValue);

			fM.addEvent(folder_a, 'click', fM.openFolder, false);
			if (!folder_a.onclick) 
			{
				folder_a.onclick = function() { return false; }; // Safari
			}
			ul_folders.appendChild(li_folder);
		}
		
		fM.setTargets();

		setTimeout(fM.setUpDraggables, 100);

	},

	receiveFilenames: function(dom, path) 
	{
	
/*
<filemanager>
	<parent_path>/mxfb-0.2</parent_path>
	<folders>
		<folder>_</folder>
	</folders>
	<files>
		<file> 											<== Entry Point A
			<name>1.html</name>
			<size>20</size>
			<mtime>January 27 2006 14:39:19.</mtime>
		</file>
		<file>
			<name>2.html</name>
			<size>20</size>
			<mtime>January 27 2006 14:39:19.</mtime>
		</file>
		<file>
			<name>index.php</name>
			<size>31904</size>
			<mtime>January 26 2006 09:49:14.</mtime>
		</file>
		<file>
			<name>readme.txt</name>
			<size>1860</size>
			<mtime>January 26 2006 09:50:32.</mtime>
		</file>
	</files>
</filemanager>
*/
		// View Options:
		//		1 = icon
		//		2 = detail
		var	viewOption = 2;
		
		var files = document.getElementById('files_body');
		files.innerHTML = '';
    
		if (viewOption == 1)
		    var ul = document.createElement('ul');
		    
		if (viewOption == 2)
		{
			var tbl = document.createElement('table');
			tbl.setAttribute("border", "0");
			tbl.setAttribute("cellpadding", "1");
			tbl.setAttribute("cellspacing", "0");
			var tbl_tr = document.createElement('tr');
			tbl.appendChild(tbl_tr);

			var tbl_tr_td = document.createElement('td');
			tbl_tr.appendChild(tbl_tr_td);
			tbl_tr_td.setAttribute("align", "center");
			tbl_tr_td.setAttribute("nowrap", "nowrap");
			tbl_tr_td.setAttribute("width", "50%");
			var tbl_tr_td_text = document.createTextNode("File name");
			tbl_tr_td.appendChild(tbl_tr_td_text);						

			var tbl_tr_td = document.createElement('td');
			tbl_tr_td.setAttribute("align", "center");
			tbl_tr_td.setAttribute("width", "20%");
			tbl_tr_td.setAttribute("nowrap", "nowrap");
			tbl_tr.appendChild(tbl_tr_td);
			
			var tbl_tr_td_text = document.createTextNode("Size");
			tbl_tr_td.appendChild(tbl_tr_td_text);						

			var tbl_tr_td = document.createElement('td');
			tbl_tr_td.setAttribute("align", "center");
			tbl_tr_td.setAttribute("width", "30%");
			tbl_tr_td.setAttribute("nowrap", "nowrap");
			tbl_tr.appendChild(tbl_tr_td);
			
			var tbl_tr_td_text = document.createTextNode("Modified Date");
			tbl_tr_td.appendChild(tbl_tr_td_text);						


	    }
	    // Entry point A
    	var fileNodes = dom.getElementsByTagName('file');

		// Loop throught the <file> sections.
		for (var files_idx = 0; files_idx < fileNodes.length; files_idx++)
		{
			// fileDetailNodes will contain one <file> section. 
			var fileDetailNodes = fileNodes[files_idx].childNodes;

			if (viewOption == 1)	
			{
				var li = document.createElement('li');
				li.className = 'draggable';
		

				// Now process the contents (child Nodes) of the single <file> section
				for (var detail_idx = 0; detail_idx < fileDetailNodes.length; detail_idx++)
				{
					// Each instance return is going to br <name> or <size> or <mtime>
					tmp_node = fileDetailNodes[detail_idx];
	
					if (tmp_node.nodeType == 1)
					{
						//li.innerHTML += tmp_node.nodeName+"=["+tmp_node.firstChild.nodeValue+"]<br />";
						li.innerHTML += tmp_node.firstChild.nodeValue+"<br />";
					}
				}
				ul.appendChild(li);
			}
			if (viewOption == 2)
			{
				var tbl_tr = document.createElement('tr');
				tbl.appendChild(tbl_tr);
				
				// Now process the contents (child Nodes) of the single <file> section
				for (var detail_idx = 0; detail_idx < fileDetailNodes.length; detail_idx++)
				{
					// Each instance return is going to br <name> or <size> or <mtime>
					tmp_node = fileDetailNodes[detail_idx];
	
					if (tmp_node.nodeType == 1)
					{
						//li.innerHTML += tmp_node.nodeName+"=["+tmp_node.firstChild.nodeValue+"]<br />";
						//li.innerHTML += tmp_node.firstChild.nodeValue+"<br />";
						var tbl_tr_td = document.createElement('td');
						
						tbl_tr.appendChild(tbl_tr_td);
						
						if (tmp_node.nodeName == "name")
							tbl_tr_td.className = 'draggable';

//						if (tmp_node.nodeName == "size")
//						{
//							tbl_tr_td.setAttribute("align", "right");
//							var tbl_tr_td_text = document.createTextNode(tmp_node.firstChild.nodeValue+"");
//						}
//						else
							var tbl_tr_td_text = document.createTextNode(tmp_node.firstChild.nodeValue);
						
						tbl_tr_td.appendChild(tbl_tr_td_text);						
					}
				}
			}
		}

		if (viewOption == 1)		
			files.appendChild(ul);
		if (viewOption == 2)
			files.appendChild(tbl);
			
		setTimeout(fM.setUpDraggables, 100);
	},

	addEvent: function(elm, evType, fn, useCapture) 
	{
		// cross-browser event handling for IE5+, NS6 and Mozilla
		// By Scott Andrew
		if (elm.addEventListener) 
		{
			elm.addEventListener(evType, fn, useCapture);
			return true;
		} 
		else if (elm.attachEvent) 
		{
			var r = elm.attachEvent('on' + evType, fn);
			return r;
		} 
		else 
		{
			elm['on' + evType] = fn;
		}
	},
  
	// Based on findPos*, by ppk (http://www.quirksmode.org/js/findpos.html)
	findPosX: function(obj) 
	{
		var curLeft = 0;
    	if (obj.offsetParent) 
    	{
			do 
			{
				curLeft += obj.offsetLeft;
			} while (obj = obj.offsetParent);
		}
		else if (obj.x) 
		{
			curLeft += obj.x;
		}
		return curLeft;
	},
  
	findPosY: function(obj) 
	{
		var curTop = 0;
		if (obj.offsetParent) 
		{
			do 
			{
				curTop += obj.offsetTop;
      		} while (obj = obj.offsetParent);
    	}
    	else if (obj.y) 
    	{
			curTop += obj.y;
    	}
    	return curTop;
  	}
}

fM.addEvent(window, 'load', fM.init, false);